#include <iostream>
using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    long long d[300000], k[300000], u[300000], o[300000];
    for (int i=0; i<n; i++) {
  	
        cin >>d[i]>>k[i];
    }

    for (int i=0; i<q; i++) {
        cin >>u[i];
    }

    for (int i=0; i<q; i++) {
    	
        long long tr=u[i], uk=0, po=0;
        
        for (int j = 0; j < n; j++) {
            if (d[j]>tr) {
            	
                break;
                
            }

            long long br=d[j]-po;
            

            if (d[j] > tr) { 
            
                br=tr-po;
                
            }

            if (br > k[j]) {
            	
                uk+=k[j];
                
            } else {
            	
                uk+=br;
                
            }


            po=d[j];
        }
        o[i]=uk;
    }
    for (int i=0; i < q; ++i) {
    	
        cout <<o[i]<<endl;
        
    }

    return 0;
}